#!/usr/bin/env python
# -*- coding: utf-8 -*-

# # 1A.e - Correction de l'interrogation écrite du 14 novembre 2014
# 
# dictionnaires

# In[1]:


from jyquickhelper import add_notebook_menu
add_notebook_menu()


# ### Enoncé 1

# #### Q1
# 
# Le code suivant produit une erreur. Laquelle ?

# In[2]:


def make_squares(n):
    squares = [i**2 for i in range(n)]


# Comme il n'y a pas d'instruction return, la fonction retourne toujours ``None`` quelque chose le résultat de ce qu'elle calcule.

# In[3]:


def make_squares(n):
    squares = [i**2 for i in range(n)]
print ( make_squares(2) )


# #### Q2
# 
# Que vaut ``a`` ?

# In[4]:


s = 1
a = 0
for i in range(4):
    a += s
    s += 2


# In[5]:


a


# Si on affiche les résultats intermédiaires :

# In[6]:


s = 1
a = 0
for i in range(4):
    print(a,s)
    a += s
    s += 2
    
a


# #### Q3
# 
# On rappelle que ``ord('a')=97``. Que vaut ``x`` ?

# In[7]:


d = {i:chr(i+97) for i in range(10)}
x = d[4]


# In[8]:


x


# Il suffit de remplacer ``i`` par 4. ``x`` vaut ``chr(97+4)`` et on se déplace de 4 lettres dans l'alphabet, soit ``e``.

# #### Q4
# 
# Que fait le programme suivant ?

# In[9]:


notes = { "Alice": 17, "Bob": 18, "Jean−Ma": 17 }
notes['Claire'] = 18

def mystere(d):
    a = 0
    b = []
    for k,v in d.items():
        if v >= a:
            a = v
            b.append(k)
    return (b,a)

print(mystere(notes))


# In[10]:


notes


# Le programme commence par ajouter la clé ``Claire`` au dictionnaire. La variable ``a`` mémorise la valeur numérique la plus grande. En l'état, le résultat programme est assez imprévisible puisqu'il dépend de l'ordre dans lequel on parcourt les éléments. Je pense que la fonction devrait récupérer dans une liste l'ensemble des prénoms correspondant à cette valeur maximale s'il était écrit comme ceci :

# In[11]:


notes = { "Alice": 17, "Bob": 18, "Jean−Ma": 17 }
notes['Claire'] = 18

def mystere(d):
    a = 0
    b = []
    for k,v in d.items():
        if v == a:
            b.append(k)
        elif v > a:
            a = v
            b = [ k ]
    return (b,a)

print(mystere(notes))


# #### Q5
# 
# Que renvoie la fonction suivante en fonction de ``n`` ?

# In[12]:


def f(n):
    while n != 1:
        if n%2 == 0:
            n = n/2
        else:
            n = 3*n + 1
    return n


# In[13]:


f(3)


# In[14]:


f(4)


# D'après la condition indiquée dans la boucle ``while``, la fonction retourne 1. Reste à savoir si cela est toujours possible quelque soit $n$. Cette question était un peu hors sujet. Il faudrait étudier la convergence de la suite $u_{n+1}=f(u_n)$ où $f$ est la fonction :
# 
# $f(n) = \left\{ \begin{array}{ll} \frac{n}{2} & si \; n \; pair \\ 3n+1 &sinon \end{array}\right.$
# 
# Ce problème n'est pas évident puisqu'il ressemble beaucoup à la [conjecture de Syracuse](http://fr.wikipedia.org/wiki/Conjecture_de_Syracuse).

# In[15]: